//+------------------------------------------------------------------+
//|                                                RenkoEA LUHAN.mq4 |
//|                                            Copyright 2013, Dasio |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Dasio"
#property link      ""


extern int MagicNumber=494949494;
extern double Lots=0.1;
extern string MaFast="Ma Fast Paramenters";
extern int MaFastPeriod=5;
extern int MaFastMethod=MODE_EMA;
extern int MaFastPrice=PRICE_OPEN;
extern string MaMedium="Ma Medium Paramenters";
extern int MaMediumPeriod=14;
extern int MaMediumMethod=MODE_SMA;
extern int MaMediumPrice=PRICE_OPEN;
extern string MaSlow="Ma Slow Paramenters";
extern int MaSlowPeriod=20;
extern int MaSlowMethod=MODE_SMA;
extern int MaSlowPrice=PRICE_OPEN;
extern string PSAR="PSAR Paramenters";
extern double SARStep=0.02;
extern double SARMax=0.03;
extern string CCI="CCI Paramenters";
extern int CCIPeriod=14;
extern double CCIPrice=PRICE_TYPICAL;
extern int CCIHighLevel=+100;
extern int CCILowLevel=-100;
double op_;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
double op_=Open[0];
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
if(op_!=Open[0]){
   op_=Open[0];
       double MAMedium=iMA(Symbol(),0,MaMediumPeriod,0,MaMediumMethod,MaMediumPrice,1);
       double MAFast=iMA(Symbol(),0,MaFastPeriod,0,MaFastMethod,MaFastPrice,0);
       double MALow=iMA(Symbol(),0,MaSlowPeriod,0,MaSlowMethod,MaSlowPrice,0);
       double PSar=iSAR(Symbol(),0,SARStep,SARMax,0);
       double CCI=iCCI(Symbol(),0,CCIPeriod,CCIPrice,0);

               if(OTBMBuy(MagicNumber)>0){
                                         if(Close[1]< MAMedium) CloseBuy(MagicNumber);
                                       }
              if(OTBMSell(MagicNumber)>0){
                                         if(Close[1]> MAMedium) CloseSell(MagicNumber);
                                       }
               if(OTBMBuy(MagicNumber)+OTBMSell(MagicNumber)<=0){
                                       if(Open[0]>MAFast && Open[0]> MALow && PSar<Open[0] && CCI>CCIHighLevel) OpenBuy(MagicNumber);
                                       if(Open[0]<MAFast && Open[0]< MALow && PSar>Open[0] && CCI<CCILowLevel) OpenSell(MagicNumber);}


}
   return(0);
  }
//+------------------------------------------------------------------+


int OTBMBuy(int intMagic)//OrdersTotalByMagic
{
int intCount=0;
int intPOS=0;
bool boolTerm=false;
while(boolTerm==false)
       {
            if(OrderSelect(intPOS,SELECT_BY_POS))
               {
              if(OrderMagicNumber()==intMagic && OrderType()==OP_BUY) intCount++;
               intPOS++;
               }
               else
               boolTerm=true;
               }
return(intCount);
}

int OTBMSell(int intMagic)//OrdersTotalByMagic
{
int intCount=0;
int intPOS=0;
bool boolTerm=false;
while(boolTerm==false)
{
if(OrderSelect(intPOS,SELECT_BY_POS))
{
if(OrderMagicNumber()==intMagic && OrderType()==OP_SELL) intCount++;
intPOS++;
}
else
boolTerm=true;
}
return(intCount);
}


void CloseBuy(int intMagic)//CloseByMagic
{
int intOffset=0;
int Count = OTBMBuy(intMagic);

while(OTBMBuy(intMagic)>0 && Count > 0)
{
OrderSelect(intOffset,SELECT_BY_POS);
if(OrderMagicNumber()==intMagic)
{
if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),999,Red);
Count--;
}
else {
intOffset++;
}
}
return;
}

void CloseSell(int intMagic)//CloseByMagic
{
int intOffset=0;
int Count = OTBMSell(intMagic);

while(OTBMSell(intMagic)>0 && Count > 0)
{
OrderSelect(intOffset,SELECT_BY_POS);
if(OrderMagicNumber()==intMagic)
{
if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),999,Orange);
Count--;
}
else {
intOffset++;
}
}
return;
}


void OpenBuy(int MagicNumber){
int Ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,2,0,0,"",MagicNumber,0,Blue); 
       // OrderModify(Ticket,OrderOpenPrice(),UltimoSegnale(),0,0,Green);
return;
}

void OpenSell(int MagicNumber){
int Ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,2,0,0,"",MagicNumber,0,Red); 
       //  OrderModify(Ticket,OrderOpenPrice(),UltimoSegnale(),0,0,Green);
         return;
}